[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.69 and 1.74

version 1.69, 2021/12/11 05:08:38 version 1.74, 2021/12/11 20:57:51
Line 50 
Line 50 
         echo "$_dir"          echo "$_dir"
 }  }
   
 realpath () {  
         if [ -x /usr/bin/realpath ]; then  
                 /usr/bin/realpath "$1"  
         elif [ "$1" = "${1%/*}" ]; then  
                 echo "${PWD}/$1"  
         else  
                 echo "$( cd "${1%/*}" && pwd )/${1##*/}"  
         fi  
 }  
   
 fetch() {  fetch() {
         local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _exit          local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _exit
   
Line 131 
Line 121 
 }  }
   
 add_firmware () {  add_firmware () {
         local _f="${1##*/}" _pkgdir="${DESTDIR}/var/db/pkg"          local _f="${1##*/}"
           local _pkgdir="${DESTDIR}/var/db/pkg/${_f%.tgz}"
         ftp -D "Install" -Vmo- "file:${1}" |          ftp -D "Install" -Vmo- "file:${1}" |
                 tar -s ",^\+,${_pkgdir}/${_f%.tgz}/+," \                  tar -s ",^\+,${_pkgdir}/+," \
                     -s ",^firmware,${DESTDIR}/etc/firmware," \                      -s ",^firmware,${DESTDIR}/etc/firmware," \
                     -C / -zxphf - "+*" "firmware/*"                      -C / -zxphf - "+*" "firmware/*"
   
         # TODO: Should we mark these so real fw_update can -Drepair?          # TODO: Should we mark these so real fw_update can -Drepair?
         ed -s "${_pkgdir}/${_f%.tgz}/+CONTENTS" <<EOL          ed -s "${_pkgdir}/+CONTENTS" <<EOL
 /^@comment pkgpath/ -1a  /^@comment pkgpath/ -1a
 @option manual-installation  @option manual-installation
 @option firmware  @option firmware
Line 215 
Line 206 
         exit          exit
 fi  fi
   
 # Have to find the full path to firmware files  if "$DOWNLOAD"; then
 # so we can cd and still find them later.  
 i=0  
 while (( i < "${#devices[@]}" )); do  
         f="${devices[$i]}"  
         d=$( firmware_devicename "$f" )  
         if [ -e "$f" ]; then  
                 if "$DOWNLOAD"; then  
                         echo "Cannot download local file $f" >&2  
                         exit 2  
                 fi  
                 devices[$i]="$d:$( realpath "$f" )"  
         fi  
         i=$((i + 1))  
 done  
   
 if "$DOWNLOAD" && ! [[ -e "$CFILE" ]]; then  
         fetch "$CFILE"          fetch "$CFILE"
         ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&          ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
             echo "Signature check of SHA256.sig failed" >&2 && exit 1              echo "Signature check of SHA256.sig failed" >&2 && exit 1
 fi  fi
   
 for d in "${devices[@]}"; do  for f in "${devices[@]}"; do
         f="${d##*:}"          d="$( firmware_devicename "$f" )"
   
         if [ "$f" = "$d" ]; then          if [ "$f" = "$d" ]; then
                 f=$( firmware_filename "$d" || true )                  f=$( firmware_filename "$d" || true )
                 [ "$f" ] || continue                  [ "$f" ] || continue
                 f="$LOCALSRC/$f"                  f="$LOCALSRC/$f"
         else          elif ! "$INSTALL" && ! grep -q "($f)" "$CFILE" ; then
                 d="${d%:*}"                  echo "Cannot download local file $f" >&2
                   exit 2
         fi          fi
   
         set -A installed -- $( installed_firmware "$d" )          set -A installed -- $( installed_firmware "$d" )
Line 258 
Line 235 
                 done                  done
         fi          fi
   
         if [ ! -e "$f" ]; then          if [ -e "$f" ]; then
                 "$INSTALL" && ! "$DOWNLOAD" &&                  if "$DOWNLOAD"; then
                     echo "Cannot install ${f##*/}, not found" >&2 && continue                          echo "Verify existing ${f##*/}"
                           verify "$f" || continue
                   # else assume it was verified when downloaded
                   fi
           elif "$INSTALL" && ! "$DOWNLOAD"; then
                   echo "Cannot install ${f##*/}, not found" >&2
                   continue
           else
                 fetch  "$f" || continue                  fetch  "$f" || continue
                 verify "$f" || continue  
         elif $DOWNLOAD; then  
                 echo "Already have $f"  
                 verify "$f" || continue                  verify "$f" || continue
         fi          fi
   

Legend:
Removed from v.1.69  
changed lines
  Added in v.1.74

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>